'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _reactRouter = require('react-router');

var _FluxController = require('../app/flux/FluxController');

var _FluxController2 = _interopRequireDefault(_FluxController);

var _ProxyRestClient = require('./ProxyRestClient');

var _ProxyRestClient2 = _interopRequireDefault(_ProxyRestClient);

var _createMemoryHistory = require('history/lib/createMemoryHistory');

var _createMemoryHistory2 = _interopRequireDefault(_createMemoryHistory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//const ApiProxyRegistry = function () {
//    const _registry = {
//        get: [],
//        post: []
//    };
//
//    function buildRoute(basePath, route) {
//        if (!route.method) {
//            route.method = 'get';
//        }
//
//        const routes = _registry[route.method];
//        let path = basePath + route.path;
//        if (!path.match(/\/$/g)) {
//            path = `${path}/`;
//        }
//
//        if (routes) {
//            routes.push({path, handler: route.handler});
//        }
//    }
//
//    return {
//        register(path, routes) {
//            for (let i = 0; i < routes.length; i++) {
//                buildRoute(path, routes[i]);
//            }
//
//            return this;
//        },
//
//        handle(req) {
//            const deferred = Promise.defer();
//
//            //console.log("Registry handle: ", req);
//
//            const method = req.method || 'get';
//            let path = req.path || '';
//            if (!path.match(/\/$/g)) {
//                path = `${path}/`;
//            }
//
//            const session = req.session;
//            const user = req.user;
//            const data = req.data;
//
//            const routes = _registry[method];
//
//            let matchingRoute = null;
//            for (let i = 0; i < routes.length; i++) {
//                const route = routes[i];
//                if (path === route.path) {
//                    matchingRoute = route;
//                    break;
//                }
//            }
//
//            if (!matchingRoute) {
//                deferred.reject({statusCode: 500, entity: `No matching route for path: ${path}`});
//            } else {
//                const proxyRequest = {session, user, body: data};
//
//                let _statusCode;
//
//                const proxyResponse = {
//                    status(statusCode) {
//                        _statusCode = statusCode;
//                        return this;
//                    },
//
//                    json(obj) {
//                        deferred.resolve({
//                            statusCode: _statusCode,
//                            entity: obj
//                        });
//                        return this;
//                    }
//                };
//
//                matchingRoute.handler(proxyRequest, proxyResponse);
//            }
//
//            return deferred.promise;
//        }
//    };
//};

exports.default = (routes, multiInstance, propertiesOrBuilder, api) => (req, res) => {
    (0, _reactRouter.match)({ routes, location: req.url }, (error, redirectLocation, renderProps) => {
        if (error) {
            res.status(500).send(error.message);
        } else if (redirectLocation) {
            res.redirect(302, redirectLocation.pathname + redirectLocation.search);
        } else if (renderProps) {
            let properties = propertiesOrBuilder;
            if (_lodash2.default.isFunction(propertiesOrBuilder)) {
                try {
                    properties = propertiesOrBuilder(_lodash2.default.defaultsDeep({}, req.params, renderProps));
                } catch (err) {
                    res.status(404).send('Not found');
                    return;
                }
            }

            const fluxController = new _FluxController2.default(properties);
            const fluxContext = fluxController.fluxContext;

            fluxContext.restClient = new _ProxyRestClient2.default(req, api);

            const createFluxComponent = (Component, props) => _react2.default.createElement(Component, (0, _extends3.default)({}, props, { fluxController: fluxController }));

            const markup = (0, _server.renderToString)(_react2.default.createElement(_reactRouter.RouterContext, (0, _extends3.default)({}, renderProps, { history: (0, _createMemoryHistory2.default)(), createElement: createFluxComponent })));

            res.render('index', {
                pageContent: markup,
                fluxStoreContent: fluxController.renderToString(),
                properties
            });
        } else {
            res.status(404).send('Not found');
        }
    });
}; /*
    * ____________________
    *
    * 360fy CONFIDENTIAL
    * ____________________
    *
    * [2015] - [2016] 360fy Technologies Private Limited
    * All Rights Reserved.
    *
    * NOTICE:  All information contained herein is, and remains
    * the property of 360fy Technologies Private Limited and its partners,
    * if any.  The intellectual and technical concepts contained
    * herein are proprietary to 360fy Technologies Private Limited
    * and its partners and may be covered by India and Foreign Patents,
    * patents in process, and are protected by trade secret or copyright law.
    * Dissemination of this information or reproduction of this material
    * is strictly forbidden unless prior written permission is obtained
    * from Adobe Systems Incorporated.
    *
    */